// important: add ws2_32.lib to the list of Object/Library modules
// to do that go to Project -> settings -> link(tab) or link will fail!
// also, InitCommonControls(); requires comctl32.lib in linker options

// sometime this is useful
//			HCURSOR tmpcurs=SetCursor(LoadCursor(NULL,IDC_WAIT));
//			SetCursor(tmpcurs);

#include <windows.h>
#include <commctrl.h> // InitCommonControls() just in case...
#include <string.h>
#include <stdio.h>
#include "procs.h"
#include "sock.h"

bool scanning=FALSE;
sock * mysock;// also used to determine if connection is established
HINSTANCE hInst;//Global handles are used in wproc and others

HWND whandle; // main window handle
HWND iplablehandle; // Lables don't need IDs (see procs.h)
HWND iphandle;
HWND portlablehandle;
HWND porthandle;
HWND tcpudphandle;
HWND conhandle;
HWND protlablehandle;
HWND prothandle;
HWND comlablehandle;
HWND comhandle;
HWND helphandle;
HWND sendhandle;
HWND outhandle;
HWND clrhandle;
HWND scanhandle;



int initchild(HWND hWnd){
// Initialize all child controls here
InitCommonControls(); // load the DLL
// IP address field
iplablehandle=CreateWindow("STATIC","Address/IP", WS_VISIBLE | WS_CHILD,
10,10,100,30, hWnd, NULL, hInst, NULL);
iphandle=CreateWindow("EDIT",NULL, WS_VISIBLE | WS_CHILD | WS_BORDER | ES_AUTOHSCROLL |WS_TABSTOP,
95,10,150,22, hWnd, (HMENU)IPID, hInst, NULL);
SendMessage(iphandle,EM_LIMITTEXT,MAXIPLEN,0); // limit the size of ip to 100
SetFocus(iphandle);
// port # field
portlablehandle=CreateWindow("STATIC","Port", WS_VISIBLE | WS_CHILD,
270,10,100,30, hWnd, NULL, hInst, NULL);
porthandle=CreateWindow("EDIT",NULL, WS_VISIBLE | WS_CHILD | WS_BORDER|WS_TABSTOP,
310,10,50,22, hWnd, (HMENU)PORTID, hInst, NULL);
// select if we are using TCP or UDP connection
tcpudphandle=CreateWindow("COMBOBOX","",WS_VISIBLE|WS_CHILD|WS_BORDER|CBS_DROPDOWNLIST|WS_TABSTOP,
380,10,100,100,hWnd,(HMENU)TCPUDPID,hInst,NULL);
SendMessage(tcpudphandle,CB_ADDSTRING,0,(long)"TCP");
SendMessage(tcpudphandle,CB_ADDSTRING,0,(long)"UDP");
SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // Set default to TCP
// connect/disconnect button
conhandle=CreateWindow("BUTTON","CONNECT", WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON|WS_TABSTOP,
500,10,110,30, hWnd, (HMENU)CONID, hInst, NULL);
// protocol selection (pull down)
protlablehandle=CreateWindow("STATIC","Protocol", WS_VISIBLE | WS_CHILD,
10,60,100,30, hWnd, NULL, hInst, NULL);
prothandle=CreateWindow("COMBOBOX",NULL, WS_VISIBLE | WS_CHILD | WS_BORDER | CBS_DROPDOWNLIST | CBS_SORT|WS_TABSTOP,
95,60,150,200, hWnd, (HMENU)PROTID, hInst, NULL);
initprots(); // Initialize protocols selection with protocol names
// command selection (pull down)
comlablehandle=CreateWindow("STATIC","Command", WS_VISIBLE | WS_CHILD,
10,110,150,30, hWnd, NULL, hInst, NULL);
comhandle=CreateWindow("COMBOBOX",NULL, WS_VISIBLE | WS_CHILD | WS_BORDER | CBS_DROPDOWN | CBS_AUTOHSCROLL | CBS_SORT|WS_TABSTOP,
160,110,400,350, hWnd, (HMENU)COMID, hInst, NULL);
SendMessage(comhandle,EM_LIMITTEXT,MAXCOMLEN,0);
// help on query button
helphandle=CreateWindow("BUTTON","HELP", WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON|WS_TABSTOP,
425,60,60,30, hWnd, (HMENU)HELPID, hInst, NULL);
// send query button
sendhandle=CreateWindow("BUTTON","SEND", WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON|WS_TABSTOP,
500,60,60,30, hWnd, (HMENU)SENDID, hInst, NULL);
// clear output window button
clrhandle=CreateWindow("BUTTON","CLEAR",WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON | DS_LOCALEDIT|WS_TABSTOP,
350,60,60,30,hWnd,(HMENU)CLRID,hInst,NULL);
// scan button ( starts port scanning )
scanhandle=CreateWindow("BUTTON","SCAN",WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON | DS_LOCALEDIT | WS_TABSTOP,
275,60,60,30,hWnd,(HMENU)SCANID,hInst,NULL);
// output window
outhandle=CreateWindow("EDIT",NULL, WS_VISIBLE | WS_CHILD | WS_BORDER | WS_VSCROLL | ES_MULTILINE | ES_AUTOVSCROLL,
10,160,615,280, hWnd, (HMENU)OUTID, hInst, NULL);
return 0; // From WM_CREATE - it has to be 0!
}




// Window Proc for Main Window handles messages from all child controls
LRESULT CALLBACK wproc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
char protstr[MAXPROTLEN];
static char ip[MAXIPLEN];
char port[MAXPORTLEN];
char tempstr[1024];
int tempint;
static int intport;

	switch(uMsg){
	case WM_CREATE:
		return initchild(hWnd);

	case WM_DESTROY:
		delete(mysock); // Close the connection before exiting
		PostQuitMessage(0);
		break;

/*
When one of the nominated network events occurs on the specified socket s,
the application's window hWnd receives message wMsg. The wParam parameter
identifies the socket on which a network event has occurred. The low word
of lParam specifies the network event that has occurred. The high word of
lParam contains any error code. The error code be any error as defined in
Winsock2.h.
*/
	case WM_NET:
		if( (LOWORD(lParam) & FD_CONNECT) == FD_CONNECT){
			tempint=HIWORD(lParam); // see if there is an error
			if(scanning){
				sprintf(tempstr,"%d",intport); // print current port #
				SendMessage(porthandle,WM_SETTEXT,0,(long)tempstr);

				if(!tempint){ // connected
					mysock->disconn(); // disconnect rigt away
					sprintf(tempstr,"Service available on port %d %s\r\n",intport,listport(intport));
					display(tempstr);
				}
//				if(tempint!=WSAETIMEDOUT && tempint!=WSAECONNREFUSED && tempint!=WSAENOTCONN){
//					SendMessage(whandle,WM_RESETNET,(long)"ERROR",(long)"Network error occured while scanning.\r\n");
//					break;
//				}
				intport++;
				if(intport > 0xFFFF){
					SendMessage(whandle,WM_RESETNET,(long)"NOTE",(long)"Scanned up to the maximum range of port #s.");
					break;
				}
				tempint=mysock->conn(ip,intport);
				if(tempint){ // Error will be displayed by conn()
					SendMessage(whandle,WM_RESETNET,0,0);
					break;
				}
				break; // we don't care about other messages when scanning
			}
			else{ // regular connection
				if (tempint){
					SendMessage(whandle,WM_RESETNET,(long)"ERROR",(long)"Connection Failed.");
				}
				else{ // connection succeeded
					SendMessage(conhandle,WM_SETTEXT,0,(long)"DISCONNECT");
					SendMessage(whandle,WM_SETTEXT,0,(long)"NetPlorer - Connected");
				}
			}
		}
		if( (LOWORD(lParam) & FD_READ) == FD_READ){
			tempint = mysock->read(tempstr,sizeof(tempstr));
			if(tempint > 0){
				tempstr[tempint]=(char)NULL;
				display(tempstr);
			}
			else SendMessage(whandle,WM_RESETNET,(long)"ERROR",(long)"Error reading from socket.");
		}
		if( (LOWORD(lParam) & FD_CLOSE) == FD_CLOSE){
			SendMessage(whandle,WM_RESETNET,(long)"NOTE",(long)"Connection closed");
		}
		break;

	case WM_RESETNET:
		scanning=FALSE;
		delete(mysock);
		mysock=NULL;
		SendMessage(scanhandle,WM_SETTEXT,0,(long)"SCAN");
		SendMessage(conhandle,WM_SETTEXT,0,(long)"CONNECT");
		SendMessage(whandle,WM_SETTEXT,0,(long)"NetPlorer");
		if(lParam) MessageBox(whandle,(char*)lParam,(char*)wParam,MB_OK);
		break;

	case WM_COMMAND: // Child Windows (button) commands

		switch(LOWORD(wParam)){ // check for button IDs

		case CONID: // Connect to server or disconnect
			if(scanning) break;
			if(HIWORD(wParam)!=BN_CLICKED) break;
			if(!mysock){ // socket does not exist 
				SendMessage(iphandle,WM_GETTEXT,MAXIPLEN,(long)ip);
				if(strlen(ip)<4){
					MessageBox(whandle,"Invalid IP","ERROR",MB_OK);
					break;
				}
				SendMessage(porthandle,WM_GETTEXT,MAXPORTLEN,(long)port);
				if(sscanf(port,"%d",&intport)!=1 || !intport || intport > 0xFFFF){
					MessageBox(whandle,"Invalid port #","ERROR",MB_OK);
					break;
				}
				tempint=SendMessage(tcpudphandle,CB_GETCURSEL,0,0);
				mysock= new sock(!tempint,whandle); // tempint: 0=TCP 1=UDP
				wsprintf(tempstr,"Connecting to %s:%s\r\n",ip,port);
				display(tempstr);
				tempint=mysock->conn(ip,intport); // >0 is error
				if(tempint)	SendMessage(whandle,WM_RESETNET,0,0);
			}
			else{ // currently connected need to disconnect
				SendMessage(whandle,WM_RESETNET,(long)"NOTE",(long)"Disconnected");
			}
			break;

// Doesn't work... works only under NT?
//		case OUTID: // pressing enter in edit same as clicking send button
//			if(HIWORD(wParam)!=BN_CLICKED) break;
//			MessageBox(whandle,"Input detected","DEBUG",MB_OK); // get input instead
//no break - continue to SENDID. if(...!=BN_CLICKED) will not get tempstr
// but instead the string acquired here will be used.

		case SENDID: // send command to server
			if(scanning) break;
			if(!mysock){
				MessageBox(whandle,"Not Connected","ERROR",MB_OK);
				break;
			}
			if(HIWORD(wParam)!=BN_CLICKED) break;//delete break if OUID used
			SendMessage(comhandle,WM_GETTEXT,sizeof(tempstr),(long)tempstr);
			tempint=strlen(tempstr);
			tempstr[tempint]='\r';
			tempstr[tempint+1]='\n';
			tempstr[tempint+2]='\0';
			tempint+=2; // yes +2 not +3 (do not write NULL to socket)
			if(	mysock->write(tempstr,tempint) == tempint) display(tempstr);
			else SendMessage(whandle,WM_RESETNET,(long)"ERROR",(long)"Error Writing to socket - Closing connection.");
			break;

		case SCANID: // Toggle button
			if(scanning){
				SendMessage(whandle,WM_RESETNET,(long)"NOTE",(long)"Scanning stopped by user.");
				break; // return
			}
			if(mysock){
				MessageBox(whandle,"Please disconnect first.","WARNING",MB_OK);
				break;
			}
			SendMessage(iphandle,WM_GETTEXT,MAXIPLEN,(long)ip);
			if(strlen(ip)<4){
				MessageBox(whandle,"Invalid IP","ERROR",MB_OK);
				break;
			}
			SendMessage(porthandle,WM_GETTEXT,MAXPORTLEN,(long)port);
			if(sscanf(port,"%d",&intport)!=1 || !intport || intport > 0xFFFF){
				MessageBox(whandle,"Invalid port #","ERROR",MB_OK);
				break;
			}
			mysock= new sock(1,whandle);
			tempint=mysock->conn(ip,intport); // see WM_NET after 
			if(tempint){
				SendMessage(whandle,WM_RESETNET,0,0);
				break;
			}

			SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // set to TCP
			scanning=TRUE;
			SendMessage(scanhandle,WM_SETTEXT,0,(long)"STOP");
			SendMessage(whandle,WM_SETTEXT,0,(long)"NetPlorer - Scanning");
			display("Scanning for available TCP services...\r\n");
			break;

		case PROTID: //Protocol change
			if(scanning) break;
			if(HIWORD(wParam)==CBN_SELCHANGE){
				int cursel= SendMessage(prothandle,CB_GETCURSEL,0,0); // find current selection
				SendMessage(prothandle,CB_GETLBTEXT,cursel,(long)protstr); // get it's text form
				if(setcmds(protstr))
					MessageBox(hWnd,"Error Changing Protocol!","ERROR",MB_OK);
			}
			break;

		case HELPID: // display help on commands in output window
			if(scanning){
				display("Scan will report which ports accept TCP/IP connection.\r\n");
				break;
			}
			if(HIWORD(wParam)==BN_CLICKED) helpcmds();
			break;

		case CLRID: // clear output window
			SendMessage(outhandle,WM_SETTEXT,0,(long)"");
			break;

		} // switch(LOWORD(wParam))

		break; // CASE WM_COMMAND

		default: return DefWindowProc(hWnd, uMsg, wParam, lParam);
	} // switch(uMsg)
	return 0; // Avoid compiler warning...
}


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd){
WNDCLASS	w; //Main window class
hInst=hInstance;

    w.style=0;
    w.lpfnWndProc=wproc;
    w.cbClsExtra=0;
	w.cbWndExtra=DLGWINDOWEXTRA;
	w.hInstance=hInstance;
    w.hIcon=NULL;
	w.hCursor=NULL;
	w.hbrBackground=(HBRUSH)COLOR_BACKGROUND; 
    w.lpszMenuName=0;
	w.lpszClassName="NetPlorer";

ATOM wreg = RegisterClass(&w);
	whandle = CreateWindow("NetPlorer","NetPlorer",WS_VISIBLE | WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME | WS_MINIMIZEBOX | WS_SYSMENU ,CW_USEDEFAULT,CW_USEDEFAULT,640,480,NULL,NULL,hInstance,NULL);
	ShowWindow(whandle,SW_SHOWNORMAL); // Set show state
	UpdateWindow(whandle); // Send WM_PAINT to whandle

MSG	msg;
	while(GetMessage(&msg,0,0,0)){
        TranslateMessage(&msg); // Format Keyboard input
		DispatchMessage(&msg);
	}//! add accelerator for buttons
	UnregisterClass("NetPlorer",hInst); // Needed for Win NT?
    return msg.wParam;
} // End WinMain()