// sock.h: interface for the sock class.
#if !defined(SOCK_H_INCLUDED)
#define SOCK_H_NCLUDED

#include <windows.h>

class sock {
	WSADATA wsd;
	SOCKET s;
	HWND msghand; // Window to handle FD_READ, FD_CLOSED messages
	BOOL tcptrue;
public:
	int conn(char * ip, int port);
	int disconn(void);
	int read(char * buffer, int size);
	int write(char * buffer, int size);
	sock(BOOL tcp, HWND handler);
	~sock(); // call disconnect
};

#endif // !defined(SOCK_H_INCLUDED)
